explain_getpgrp_or_die(3)

NAME
explain_getpgrp_or_die - get process group and report errors

SYNOPSIS
#include <libexplain/getpgrp.h>

pid_t explain_getpgrp_or_die(pid_t pid);
pid_t explain_getpgrp_on_error(pid_t pid);

DESCRIPTION
The explain_getpgrp_or_die function is used to call the getpgrp(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_getpgrp(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_getpgrp_on_error function is used to call the getpgrp(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_getpgrp(3) function, but still returns to the caller.

pid The pid, exactly as to be passed to the getpgrp(2) system call.

  API Inconsistencies
Note: the getpgrp(2) function has two implementations. The POSIX.1 version has no arguments, while the BSD version has one argument. For simplicity of implementation, the argument list seen here includes the pid argument.

The POSIX.1 getpgid() semanatics can be obtained by calling getpgrp(0) on BSD systems, and this is the API for libexplain, even on systems that do not use the BSD API.

RETURN VALUE
The explain_getpgrp_or_die function only returns on success, see getpgrp(2) for more information. On failure, prints an explanation and exits, it does not return.

The explain_getpgrp_on_error function always returns the value return by the wrapped getpgrp(2) system call.

EXAMPLE
The explain_getpgrp_or_die function is intended to be used in a fashion similar to the following example:
    pid_t result = explain_getpgrp_or_die(pid);

SEE ALSO

getpgrp(2)
    get process group

explain_getpgrp(3)
    explain getpgrp(2) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version
Copyright (C) 2011 Peter Miller